/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.kandidatenportal.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="WVP_BENUTZER.All",
     query="SELECT o FROM WvpBenutzer o",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WVP_BENUTZER.Wahl",
     query="SELECT o FROM WvpBenutzer o WHERE o.wahl = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WVP_BENUTZER.WvpBenutzerkennung",
     query="SELECT o FROM WvpBenutzer o WHERE o.wvpBenutzerkennung = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WVP_BENUTZER.Zugriffscode",
     query="SELECT o FROM WvpBenutzer o WHERE o.zugriffscode=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "WVP_BENUTZER")
@javax.persistence.Cacheable
@javax.persistence.PrimaryKeyJoinColumn(name="personendaten_id")
@javax.persistence.DiscriminatorValue(WvpBenutzer.DISCRIMINATOR_VALUE)

public
 class WvpBenutzer
extends AbstractWvpBenutzer
  {

  private static final long serialVersionUID = 0L;

  public static final String DISCRIMINATOR_VALUE = "WVP_BENUTZER";

  /**
   * default constructor (protected, da mit CustomData aufgerufen werden muss)
   */
  protected WvpBenutzer() {
    super();
  }
    public WvpBenutzer(de.ivu.elect.jee.entity.customdata.CustomData customData){
        super(customData);
      }



    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public WvpBenutzer(WvpBenutzer original){
      original.copyEntity(this);
    }


  @Override
  public void resetAttributeChanged() {
        hasChangedInitialesPasswort = false;
          hasChangedWvpBenutzerkennung = false;
          hasChangedWvpBenutzerStatus = false;
          hasChangedWvpNameGebiet = false;
          hasChangedWvpNamePolitischeGruppe = false;
          hasChangedZugriffscode = false;
  


        
    super.resetAttributeChanged();
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "INITIALES_PASSWORT", nullable = WvpBenutzerConstants.INITIALES_PASSWORT_NULLABLE, length=WvpBenutzerConstants.INITIALES_PASSWORT_MAX_LENGTH)
        // ELECT-15773
  protected java.lang.String initialesPasswort =  null;

  @javax.persistence.Transient
  protected boolean hasChangedInitialesPasswort = false;

  public boolean hasChangedInitialesPasswort(){
    return hasChangedInitialesPasswort;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertInitialesPasswort = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenInitialesPasswort;
  
  /**
   * 
   *
   * getter for WVP_BENUTZER.INITIALES_PASSWORT
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getInitialesPasswort() {
        return initialesPasswort;
      }

  /**
   * 
   *
   * setter for WVP_BENUTZER.INITIALES_PASSWORT
   *
   * @param initialesPasswort
   */
  @Override   public void setInitialesPasswort(@javax.annotation.Nullable  java.lang.String initialesPasswort) {

       resetTkCache();
                  
                          java.lang.String initialesPasswortInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(initialesPasswort, WvpBenutzerConstants.INITIALES_PASSWORT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.initialesPasswort
      , initialesPasswortInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedInitialesPasswort |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("initialesPasswort");
      }


             if (!isSeitLadenVeraendertInitialesPasswort) {
          isSeitLadenVeraendertInitialesPasswort = thisAttributChanged;
         if (isSeitLadenVeraendertInitialesPasswort){
           wertNachLadenInitialesPasswort=this.initialesPasswort;
         }
       }
      

       this.initialesPasswort = initialesPasswortInternal;

         }

        
      @javax.persistence.Column(name = "WVP_BENUTZERKENNUNG", nullable = WvpBenutzerConstants.WVP_BENUTZERKENNUNG_NULLABLE, length=WvpBenutzerConstants.WVP_BENUTZERKENNUNG_MAX_LENGTH)
        
  protected java.lang.String wvpBenutzerkennung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedWvpBenutzerkennung = false;

  public boolean hasChangedWvpBenutzerkennung(){
    return hasChangedWvpBenutzerkennung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWvpBenutzerkennung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenWvpBenutzerkennung;
  
  /**
   * 
   *
   * getter for WVP_BENUTZER.WVP_BENUTZERKENNUNG
   */
    @Override   public  java.lang.String getWvpBenutzerkennung() {
        return wvpBenutzerkennung;
      }

  /**
   * 
   *
   * setter for WVP_BENUTZER.WVP_BENUTZERKENNUNG
   *
   * @param wvpBenutzerkennung
   */
  @Override   public void setWvpBenutzerkennung( java.lang.String wvpBenutzerkennung) {

       resetTkCache();
                  
                          java.lang.String wvpBenutzerkennungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(wvpBenutzerkennung, WvpBenutzerConstants.WVP_BENUTZERKENNUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wvpBenutzerkennung
      , wvpBenutzerkennungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWvpBenutzerkennung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("wvpBenutzerkennung");
      }


             if (!isSeitLadenVeraendertWvpBenutzerkennung) {
          isSeitLadenVeraendertWvpBenutzerkennung = thisAttributChanged;
         if (isSeitLadenVeraendertWvpBenutzerkennung){
           wertNachLadenWvpBenutzerkennung=this.wvpBenutzerkennung;
         }
       }
      

       this.wvpBenutzerkennung = wvpBenutzerkennungInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "WVP_BENUTZER_STATUS", nullable = WvpBenutzerConstants.WVP_BENUTZER_STATUS_NULLABLE)
    
  protected de.ivu.elect.business.kandidatenportal.entity.WvpBenutzerStatus wvpBenutzerStatus =  de.ivu.elect.business.kandidatenportal.entity.WvpBenutzerStatus.INITIAL;

  @javax.persistence.Transient
  protected boolean hasChangedWvpBenutzerStatus = false;

  public boolean hasChangedWvpBenutzerStatus(){
    return hasChangedWvpBenutzerStatus;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWvpBenutzerStatus = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.kandidatenportal.entity.WvpBenutzerStatus wertNachLadenWvpBenutzerStatus;
  
  /**
   * 
   *
   * getter for WVP_BENUTZER.WVP_BENUTZER_STATUS
   */
    @Override   public  de.ivu.elect.business.kandidatenportal.entity.WvpBenutzerStatus getWvpBenutzerStatus() {
        return wvpBenutzerStatus;
      }

  /**
   * 
   *
   * setter for WVP_BENUTZER.WVP_BENUTZER_STATUS
   *
   * @param wvpBenutzerStatus
   */
  @Override   public void setWvpBenutzerStatus( de.ivu.elect.business.kandidatenportal.entity.WvpBenutzerStatus wvpBenutzerStatus) {

       resetTkCache();
                  de.ivu.elect.business.kandidatenportal.entity.WvpBenutzerStatus wvpBenutzerStatusInternal = wvpBenutzerStatus;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wvpBenutzerStatus
      , wvpBenutzerStatusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWvpBenutzerStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("wvpBenutzerStatus");
      }


             if (!isSeitLadenVeraendertWvpBenutzerStatus) {
          isSeitLadenVeraendertWvpBenutzerStatus = thisAttributChanged;
         if (isSeitLadenVeraendertWvpBenutzerStatus){
           wertNachLadenWvpBenutzerStatus=this.wvpBenutzerStatus;
         }
       }
      

       this.wvpBenutzerStatus = wvpBenutzerStatusInternal;

         }

        
  @javax.persistence.Column(name = "WVP_NAME_GEBIET", nullable = WvpBenutzerConstants.WVP_NAME_GEBIET_NULLABLE, length=WvpBenutzerConstants.WVP_NAME_GEBIET_MAX_LENGTH)
        
  protected java.lang.String wvpNameGebiet =  null;

  @javax.persistence.Transient
  protected boolean hasChangedWvpNameGebiet = false;

  public boolean hasChangedWvpNameGebiet(){
    return hasChangedWvpNameGebiet;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWvpNameGebiet = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenWvpNameGebiet;
  
  /**
   * 
   *
   * getter for WVP_BENUTZER.WVP_NAME_GEBIET
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getWvpNameGebiet() {
        return wvpNameGebiet;
      }

  /**
   * 
   *
   * setter for WVP_BENUTZER.WVP_NAME_GEBIET
   *
   * @param wvpNameGebiet
   */
  @Override   public void setWvpNameGebiet(@javax.annotation.Nullable  java.lang.String wvpNameGebiet) {

       resetTkCache();
                  
                          java.lang.String wvpNameGebietInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(wvpNameGebiet, WvpBenutzerConstants.WVP_NAME_GEBIET_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wvpNameGebiet
      , wvpNameGebietInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWvpNameGebiet |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("wvpNameGebiet");
      }


             if (!isSeitLadenVeraendertWvpNameGebiet) {
          isSeitLadenVeraendertWvpNameGebiet = thisAttributChanged;
         if (isSeitLadenVeraendertWvpNameGebiet){
           wertNachLadenWvpNameGebiet=this.wvpNameGebiet;
         }
       }
      

       this.wvpNameGebiet = wvpNameGebietInternal;

         }

        
  @javax.persistence.Column(name = "WVP_NAME_POLITISCHE_GRUPPE", nullable = WvpBenutzerConstants.WVP_NAME_POLITISCHE_GRUPPE_NULLABLE, length=WvpBenutzerConstants.WVP_NAME_POLITISCHE_GRUPPE_MAX_LENGTH)
        
  protected java.lang.String wvpNamePolitischeGruppe =  null;

  @javax.persistence.Transient
  protected boolean hasChangedWvpNamePolitischeGruppe = false;

  public boolean hasChangedWvpNamePolitischeGruppe(){
    return hasChangedWvpNamePolitischeGruppe;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWvpNamePolitischeGruppe = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenWvpNamePolitischeGruppe;
  
  /**
   * 
   *
   * getter for WVP_BENUTZER.WVP_NAME_POLITISCHE_GRUPPE
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getWvpNamePolitischeGruppe() {
        return wvpNamePolitischeGruppe;
      }

  /**
   * 
   *
   * setter for WVP_BENUTZER.WVP_NAME_POLITISCHE_GRUPPE
   *
   * @param wvpNamePolitischeGruppe
   */
  @Override   public void setWvpNamePolitischeGruppe(@javax.annotation.Nullable  java.lang.String wvpNamePolitischeGruppe) {

       resetTkCache();
                  
                          java.lang.String wvpNamePolitischeGruppeInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(wvpNamePolitischeGruppe, WvpBenutzerConstants.WVP_NAME_POLITISCHE_GRUPPE_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wvpNamePolitischeGruppe
      , wvpNamePolitischeGruppeInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWvpNamePolitischeGruppe |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("wvpNamePolitischeGruppe");
      }


             if (!isSeitLadenVeraendertWvpNamePolitischeGruppe) {
          isSeitLadenVeraendertWvpNamePolitischeGruppe = thisAttributChanged;
         if (isSeitLadenVeraendertWvpNamePolitischeGruppe){
           wertNachLadenWvpNamePolitischeGruppe=this.wvpNamePolitischeGruppe;
         }
       }
      

       this.wvpNamePolitischeGruppe = wvpNamePolitischeGruppeInternal;

         }

        
  @javax.persistence.Column(name = "ZUGRIFFSCODE", nullable = WvpBenutzerConstants.ZUGRIFFSCODE_NULLABLE, length=WvpBenutzerConstants.ZUGRIFFSCODE_MAX_LENGTH)
        // ELECT-8808
  protected java.lang.String zugriffscode =  null;

  @javax.persistence.Transient
  protected boolean hasChangedZugriffscode = false;

  public boolean hasChangedZugriffscode(){
    return hasChangedZugriffscode;
  }
  
  /**
   * 
   *
   * getter for WVP_BENUTZER.ZUGRIFFSCODE
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getZugriffscode() {
        return zugriffscode;
      }

  /**
   * 
   *
   * setter for WVP_BENUTZER.ZUGRIFFSCODE
   *
   * @param zugriffscode
   */
  @Override   public void setZugriffscode(@javax.annotation.Nullable  java.lang.String zugriffscode) {

       resetTkCache();
                  
                          java.lang.String zugriffscodeInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(zugriffscode, WvpBenutzerConstants.ZUGRIFFSCODE_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.zugriffscode
      , zugriffscodeInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedZugriffscode |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("zugriffscode");
      }


      

       this.zugriffscode = zugriffscodeInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("WvpBenutzer:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(WvpBenutzer other){
        super.copyEntity(other);
                             other.initialesPasswort = this.initialesPasswort;
                                other.wvpBenutzerkennung = this.wvpBenutzerkennung;
                                other.wvpBenutzerStatus = this.wvpBenutzerStatus;
                                other.wvpNameGebiet = this.wvpNameGebiet;
                                other.wvpNamePolitischeGruppe = this.wvpNamePolitischeGruppe;
                                other.zugriffscode = this.zugriffscode;
           
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(WvpBenutzer.class)){
        copyEntityAttributesUsingSetter((WvpBenutzer) other.castTo(WvpBenutzer.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von WvpBenutzer: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(WvpBenutzer other){
      super.copyEntityAttributesUsingSetter(other);
               other.setInitialesPasswort(this.initialesPasswort);
                  other.setWvpBenutzerkennung(this.wvpBenutzerkennung);
                  other.setWvpBenutzerStatus(this.wvpBenutzerStatus);
                  other.setWvpNameGebiet(this.wvpNameGebiet);
                  other.setWvpNamePolitischeGruppe(this.wvpNamePolitischeGruppe);
                  other.setZugriffscode(this.zugriffscode);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }

    @Override
    public void copyEntityAttributesUsingSetter(de.ivu.elect.business.person.entity.Personendaten other){
       if (other.isInstanceOf(WvpBenutzer.class)) {
         copyEntityAttributesUsingSetter(other.castTo(WvpBenutzer.class).getEntity());
       } else {
         super.copyEntityAttributesUsingSetter(other);
       }
    }

  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(WvpBenutzer other){
       super.copyChangedEntityAttributesUsingSetter(other);
                       if (hasChangedInitialesPasswort) {
        other.setInitialesPasswort(this.initialesPasswort);
      }
                             if (hasChangedWvpBenutzerkennung) {
        other.setWvpBenutzerkennung(this.wvpBenutzerkennung);
      }
                             if (hasChangedWvpBenutzerStatus) {
        other.setWvpBenutzerStatus(this.wvpBenutzerStatus);
      }
                             if (hasChangedWvpNameGebiet) {
        other.setWvpNameGebiet(this.wvpNameGebiet);
      }
                             if (hasChangedWvpNamePolitischeGruppe) {
        other.setWvpNamePolitischeGruppe(this.wvpNamePolitischeGruppe);
      }
                             if (hasChangedZugriffscode) {
        other.setZugriffscode(this.zugriffscode);
      }
             }

    @Override
    public void copyChangedEntityAttributesUsingSetter(de.ivu.elect.business.person.entity.Personendaten other){
      if (other.isInstanceOf(WvpBenutzer.class)) {
        copyChangedEntityAttributesUsingSetter(other.castTo(WvpBenutzer.class).getEntity());
      } else {
        super.copyChangedEntityAttributesUsingSetter(other);
      }
    }




    @javax.persistence.Transient
    private transient WvpBenutzerTK tkCache;

    @Override
    protected void resetTkCache() {
    super.resetTkCache();
        tkCache = null;
    }

    public WvpBenutzerTK getWvpBenutzerTK(){
    if (tkCache==null) {
    tkCache = new WvpBenutzerTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getWvpBenutzerTK();
    }

  @Override
  public WvpBenutzerUK getUk(){
    return getWvpBenutzerUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return WvpBenutzer.class;
  }

public WvpBenutzerUK getWvpBenutzerUK(){

   return  new WvpBenutzerUK(



  );
}

  @javax.persistence.Transient
  private transient WvpBenutzerProperties properties;

  @Override
  public WvpBenutzerProperties getProperties(){
    if (properties == null) {
      properties = new WvpBenutzerProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public WvpBenutzerProperties getWvpBenutzerProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return WvpBenutzerConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
        if (super.isAenderungenProtokollieren()){
      return true;
    }
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
            super.setProtokollierteAttributeMitWerten(werteVorher);
     
      if (werteVorher.containsKey(WvpBenutzerConstants.MESSAGE_KEY_INITIALES_PASSWORT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WvpBenutzerConstants.MESSAGE_KEY_INITIALES_PASSWORT_EINZAHL);

        initialesPasswort =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WvpBenutzerConstants.MESSAGE_KEY_WVP_BENUTZERKENNUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WvpBenutzerConstants.MESSAGE_KEY_WVP_BENUTZERKENNUNG_EINZAHL);

        wvpBenutzerkennung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WvpBenutzerConstants.MESSAGE_KEY_WVP_BENUTZER_STATUS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WvpBenutzerConstants.MESSAGE_KEY_WVP_BENUTZER_STATUS_EINZAHL);

        wvpBenutzerStatus =
     (de.ivu.elect.business.kandidatenportal.entity.WvpBenutzerStatus) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WvpBenutzerConstants.MESSAGE_KEY_WVP_NAME_GEBIET_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WvpBenutzerConstants.MESSAGE_KEY_WVP_NAME_GEBIET_EINZAHL);

        wvpNameGebiet =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WvpBenutzerConstants.MESSAGE_KEY_WVP_NAME_POLITISCHE_GRUPPE_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WvpBenutzerConstants.MESSAGE_KEY_WVP_NAME_POLITISCHE_GRUPPE_EINZAHL);

        wvpNamePolitischeGruppe =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                        }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = super.getProtokollierteAttributeMitWerten();
                        if (isSeitLadenVeraendertInitialesPasswort) {
      result.put(WvpBenutzerConstants.MESSAGE_KEY_INITIALES_PASSWORT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenInitialesPasswort , initialesPasswort));
    }
                            if (isSeitLadenVeraendertWvpBenutzerkennung) {
      result.put(WvpBenutzerConstants.MESSAGE_KEY_WVP_BENUTZERKENNUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenWvpBenutzerkennung , wvpBenutzerkennung));
    }
                            if (isSeitLadenVeraendertWvpBenutzerStatus) {
      result.put(WvpBenutzerConstants.MESSAGE_KEY_WVP_BENUTZER_STATUS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenWvpBenutzerStatus , wvpBenutzerStatus));
    }
                            if (isSeitLadenVeraendertWvpNameGebiet) {
      result.put(WvpBenutzerConstants.MESSAGE_KEY_WVP_NAME_GEBIET_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenWvpNameGebiet , wvpNameGebiet));
    }
                            if (isSeitLadenVeraendertWvpNamePolitischeGruppe) {
      result.put(WvpBenutzerConstants.MESSAGE_KEY_WVP_NAME_POLITISCHE_GRUPPE_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenWvpNamePolitischeGruppe , wvpNamePolitischeGruppe));
    }
                                    return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
        super.resetProtokollierteAttribute();
                      isSeitLadenVeraendertInitialesPasswort = false;
      wertNachLadenInitialesPasswort = null;
                          isSeitLadenVeraendertWvpBenutzerkennung = false;
      wertNachLadenWvpBenutzerkennung = null;
                          isSeitLadenVeraendertWvpBenutzerStatus = false;
      wertNachLadenWvpBenutzerStatus = null;
                          isSeitLadenVeraendertWvpNameGebiet = false;
      wertNachLadenWvpNameGebiet = null;
                          isSeitLadenVeraendertWvpNamePolitischeGruppe = false;
      wertNachLadenWvpNamePolitischeGruppe = null;
                                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
           java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = super.getFachlichAbhaengigeEntitaeten();
            return result;
  }

        
            @Override
            protected String getInitialDiscriminator() {
              return "WVP_BENUTZER";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  @Override
  public boolean isPersistent() {
    return getId() != null;
  }



            
                  @Override
                public void resetValidation() {
                  super.resetValidation();
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                          @Override
                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                  validationResult.addAll(super.validateEntity());
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(WvpBenutzerConstants.INITIALES_PASSWORT_MAX_LENGTH ,  initialesPasswort, this, WvpBenutzerConstants.MESSAGE_KEY_INITIALES_PASSWORT_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(wvpBenutzerkennung, this, WvpBenutzerConstants.MESSAGE_KEY_WVP_BENUTZERKENNUNG_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(WvpBenutzerConstants.WVP_BENUTZERKENNUNG_MAX_LENGTH , 1 ,  wvpBenutzerkennung, this, WvpBenutzerConstants.MESSAGE_KEY_WVP_BENUTZERKENNUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(wvpBenutzerStatus, this, WvpBenutzerConstants.MESSAGE_KEY_WVP_BENUTZER_STATUS_EINZAHL, validationResult);
                                                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(WvpBenutzerConstants.WVP_NAME_GEBIET_MAX_LENGTH ,  wvpNameGebiet, this, WvpBenutzerConstants.MESSAGE_KEY_WVP_NAME_GEBIET_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(WvpBenutzerConstants.WVP_NAME_POLITISCHE_GRUPPE_MAX_LENGTH ,  wvpNamePolitischeGruppe, this, WvpBenutzerConstants.MESSAGE_KEY_WVP_NAME_POLITISCHE_GRUPPE_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(WvpBenutzerConstants.ZUGRIFFSCODE_MAX_LENGTH ,  zugriffscode, this, WvpBenutzerConstants.MESSAGE_KEY_ZUGRIFFSCODE_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            }
